    var iNextPageToCreate = 1;
    var myOrientation = 'portrait';
    var LastPage = -1;

//**********************************************
// FUNCTION : AddFirstPage
// Begin Page Preview
//**********************************************
    function AddFirstPage() {
      myTotalPages = 1;
      // Setup a new 'blank page'
      newHTML  = "<IE:DEVICERECT ID='page1' MEDIA='print' CLASS='pagestyle'>";
      newHTML += "<IE:LAYOUTRECT ID='layoutrect1' CONTENTSRC='document' ONLAYOUTCOMPLETE='OnRectComplete()' ONREADYSTATECHANGE='DocumentCompleteCallback()' NEXTRECT='layoutrect2' CLASS='lorstyle'/>";
      newHTML += "</IE:DEVICERECT>";

      // Insert it into the preview area
      zoomcontainer.insertAdjacentHTML("afterBegin", newHTML);

      layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;

      // Setup headers and footers
      headfoot.textHead = printer.header;
      headfoot.textFoot = printer.footer;
      headfoot.url = dialogArguments.__IE_BrowseDocument.URL;
      headfoot.title = dialogArguments.__IE_BrowseDocument.title;
      headfoot.page = 1;
      AddHeaderAndFooterToPage(1);

      // Increment counter for overflow
      iNextPageToCreate = 2;
    }

//**********************************************
// FUNCTION : AddHeaderAndFooterToPage
// Add the header and footer into relevant DIVs at top and bottom of page.
// Style sheets will ensure display is correct
//**********************************************
    function AddHeaderAndFooterToPage(pageNum) {
      newHeader = "<DIV ID='hPage" + pageNum + "' CLASS='headerstyle'>" + headfoot.htmlHead + "</DIV>";
      newFooter = "<DIV CLASS='footerstyle'>" + headfoot.htmlFoot + "</DIV>";

      document.all("page" + pageNum).insertAdjacentHTML("afterBegin", newHeader);
      document.all("page" + pageNum).insertAdjacentHTML("beforeEnd", newFooter);
    }

//**********************************************
// FUNCTION : AddNewPage
// Add a new page to the end of the document
//**********************************************
    function AddNewPage(framesFlag) {
      myTotalPages++;

      // Set completion callback function of last page to simple version
      document.all("layoutrect" + (iNextPageToCreate - 1)).onlayoutcomplete = OnRectCompleteSimple;
      headfoot.page = iNextPageToCreate;

      // Create the new page
      newHTML  = "<IE:DEVICERECT ID='page" + iNextPageToCreate +  "' MEDIA='print' CLASS='pagestyle'>";
      newHTML += "<IE:LAYOUTRECT ID='layoutrect" + iNextPageToCreate + "' ONLAYOUTCOMPLETE='OnRectComplete()' NEXTRECT='layoutrect" + (iNextPageToCreate + 1) + "'  CLASS='lorstyle'/>";
      newHTML += "</IE:DEVICERECT>";

      // Add it to the end
      zoomcontainer.insertAdjacentHTML("beforeEnd", newHTML);

      AddHeaderAndFooterToPage(iNextPageToCreate);
      headfoot.pageTotal = iNextPageToCreate;

      // If parameter has been set, then new page is the next frame.
      if (framesFlag) {
        document.all("layoutrect" + iNextPageToCreate).contentSrc = allFrames[CurrentFrameIndex];
        newHTML = "layoutrect" + iNextPageToCreate + ".contentDocument.onreadystatechange = DocumentCompleteCallback";
        eval(newHTML);
      }

      iNextPageToCreate++;
    }

//**********************************************
// FUNCTION : SetOrientation
// Change Portrait to Landscape and back
//**********************************************
    function SetOrientation(NewOrientation) {
      // The actual change
      printer.orientation = NewOrientation;
      // Record current settings
      myOrientation = NewOrientation;
      // Allow a delay for pagination to adjust
      setTimeout('ResetMargins()', 30);


      layoutrect1.contentSrc = layoutrect1.contentSrc;
      layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
    }

//**********************************************
// FUNCTION : SetCopies
// Event handler for number of copies text box
//**********************************************
    function SetCopies() {
      if (event.srcElement.id != "Copies") return;
      if (event.keyCode == 13 || event.type == "blur") {
        var newCopies = Copies.value;
        // Convert floating point to integer
        newCopies = Math.round(newCopies);

        // Must be printing 1+ copies
        if (newCopies < 1) newCopies = 1;

        // Reset value in text box in case it was invalid
        newCopies.value = newCopies;
        // Set the value in printing object
        printer.copies = newCopies;

        // Calculates new values
        NumCopies = newCopies;
        InitTotals();
      }
    }

//**********************************************
// FUNCTION : SetCollation
// Event handler for collation check box.
//   Simply set printing object to match check box.
//**********************************************
    function SetCollation() {
      if (Collate.checked) {
        printer.collate = true;
      } else {
        printer.collate = false;
      }
    }

//**********************************************
// FUNCTION : SetPageSelection
// Event handler for radio buttons dealing with page selection
//**********************************************
    function SetPageSelection(numSelection) {
      // All Pages
      if (numSelection == 1) {
        // Set values in printing object
        printer.selection = false;
        printer.selectedPages = false;
        // If frames settings are 'As On Screen'
        if (Frames[0].checked == true) {
          CurrentFrameIndex = -1;
          // Change src for first page
          layoutrect1.contentSrc = originalDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        }
        // If frames settings are 'Selected Frame'
        if (Frames[1].checked == true) {
          CurrentFrameIndex = -1;
          // Change src for first page
          layoutrect1.contentSrc = activeFrameDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        }
        // If frames settings are 'All Frames Individually'
        if (Frames[2].checked == true) {
          CurrentFrameIndex = 0;
          // Change src for first page
          layoutrect1.contentSrc = allFrames[0];
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        }

      // Selection Area Only
      } else if (numSelection == 2) {
        // If there is a selected area...
        if (selectionDoc) {
          // Set values in printing object
          printer.selection = true;
          printer.selectedPages = false;
          // Change src for first page
          layoutrect1.contentSrc = selectionDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
          // Frames are irrelevant
          Frames[0].checked = true;
          Frames[1].checked = false;
          Frames[2].checked = false;

        // Else, reset 'All Pages'
        } else {
          RadioPages[0].checked = true;
        }

      // Selected Pages
      } else if (numSelection == 3) {
        // Set values in printing object
        printer.selection = false;
        printer.selectedPages = true;
        // If frames settings are 'As On Screen'
        if (Frames[0].checked == true) {
          CurrentFrameIndex = -1;
          // Change src for first page
          layoutrect1.contentSrc = originalDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // If frames settings are 'Selected Frame'
        } else if (Frames[1].checked == true) {
          CurrentFrameIndex = -1;
          // Change src for first page
          layoutrect1.contentSrc = activeFrameDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // If frames settings are 'All Frames Individually'
        } else if (Frames[2].checked == true) {
          CurrentFrameIndex = 0;
          // Change src for first page
          layoutrect1.contentSrc = allFrames[0];
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        }
      }
    }

//**********************************************
// FUNCTION : SetPageFrom
// Event handler for 'From' text box in page selection
//**********************************************
    function SetPageFrom() {
      if (event.srcElement.id != "PageFrom") return;
      if (event.keyCode == 13 || event.type == "blur") {
        // Set values in printing object
        printer.selection = false;
        printer.selectedPages = true;
        // Set the radio button associated with this text box
        RadioPages[2].checked = true;

        // Get the new value and make sure it is an integer
        var newPage = PageFrom.value;
        newPage = Math.round(newPage);

        // Validate value based on this print job and other settings
        if (newPage < 1) newPage = 1;
        if (newPage > headfoot.pageTotal) newPage = headfoot.pageTotal;
        if (newPage > PageTo.value) newPage = PageTo.value;

        // Set value on screen and in printing object
        PageFrom.value = newPage;
        printer.pageFrom = newPage;

        layoutrect1.contentSrc = layoutrect1.contentSrc;
        layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
      }
    }

//**********************************************
// FUNCTION : SetPageTo
// Event handler for 'To' text box in page selection.
// ResetFlag is used to bypass event testing when this
//   function is used for pagination fixes.
//**********************************************
    function SetPageTo(ResetFlag) {
      if (event.srcElement.id != "PageTo") return;
      if (event.keyCode == 13 || event.type == "blur") {
        // Set values in printing object
        printer.selection = false;
        printer.selectedPages = true;
        // Set the radio button associated with this text box
        RadioPages[2].checked = true;

        // Get the new value and make sure it is an integer
        var newPage = PageTo.value;
        newPage = Math.round(newPage);

        // Validate value based on this print job and other settings
        if (newPage < 1) newPage = 1;
        if (newPage > headfoot.pageTotal) newPage = headfoot.pageTotal;
        if (newPage < PageFrom.value) newPage = PageFrom.value;

        // Set value on screen and in printing object
        PageTo.value = newPage;
        printer.pageTo = newPage;

        layoutrect1.contentSrc = layoutrect1.contentSrc;
        layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
      }
    }

//**********************************************
// FUNCTION : FramePrinting
// Event handler for radio buttons dealing with frames
//**********************************************
    function FramePrinting(numSelection) {
      // As On Screen
      if (numSelection == 1) {
        // Set printing object
        printer.frameActive = false;
        printer.frameAsShown = true;
        printer.framesetDocument = false;
        CurrentFrameIndex = -1;
        // Set source document for first page
        layoutrect1.contentSrc = originalDoc;
        layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // Reset page selection if invalid
        if (RadioPages[1].checked == true) {
          RadioPages[0].checked = true;
        }

      // Selected Frame
      } else if (numSelection == 2) {
        // Test if there is an active frame, or frames at all
        if (typeof(activeFrameIndex) != 'undefined' && TotalFrames > 0) {
          // Set printing object
          printer.frameActive = true;
          printer.frameAsShown = false;
          printer.framesetDocument = false;
          CurrentFrameIndex = -1;
          // Set source document for first page
          layoutrect1.contentSrc = activeFrameDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // No frames or active frame
        } else {
          // Invalid selection
          Frames[0].checked = true;
        }
        // Reset page selection if invalid
        if (RadioPages[1].checked == true) {
          RadioPages[0].checked = true;
        }

      // All frames individually
      } else if (numSelection == 3) {
        // Make sure there are frames
        if (TotalFrames > 0) {
          // Set printing object
          printer.frameActive = false;
          printer.frameAsShown = false;
          printer.framesetDocument = true;
          CurrentFrameIndex = 0;
          // Set source document for first page
          layoutrect1.contentSrc = allFrames[0];
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // No frames
        } else {
          // Invalid selection
          Frames[0].checked = true;
        }
        // Reset page selection if invalid
        if (RadioPages[1].checked == true) {
          RadioPages[0].checked = true;
        }
      }
    }

//**********************************************
// FUNCTION : OnRectComplete
// Callback function for completion of last page in document
//**********************************************
    function OnRectComplete() {
      if (event.contentOverflow == true) {
        // If there is still unused content, add a new page to the document
        AddNewPage(0);
      } else {
        if (printer.framesetDocument && CurrentFrameIndex < (TotalFrames - 1)) {
          // If finished this frame and there are more frames to go, add a new page
          AddNewPage(1);
        } else {
          // Else, set test condition on LastPage as there are no extra pages to be hidden
          LastPage = -1;
        }
      }
    }

//**********************************************
// FUNCTION : OnRectCompleteSimple
// Callback function for completion of other pages in document
//**********************************************
    function OnRectCompleteSimple() {
      // If more content remains, return straight away. Next page(s) exist
      //    already so no work is required.
      if (event.contentOverflow == true) {
        return;
      }

      // If printing all frames and there are more frames remaining...
      if (printer.framesetDocument == true && CurrentFrameIndex < (TotalFrames - 1)) {
        // Increment index
        CurrentFrameIndex++;
        // Get name of the layoutrect that just finished
        myTemp = new String(event.srcElement.id);
        tempNum = myTemp.length;
        tempNum = myTemp.substring(10, tempNum) - 0 + 1;
        // Set the source document for the next layoutrect to be the next frame
        myTemp = "layoutrect" + tempNum + ".contentSrc = allFrames[" + CurrentFrameIndex + "];";
        eval(myTemp);

      // No Frames, or last frame is finished
      } else {
        // Set the variable that tracks the last page to this page
        myTemp = new String(event.srcElement.id);
        tempNum = myTemp.length;
        LastPage = myTemp.substring(10, tempNum) - 0;
      }
    }

//**********************************************
// FUNCTION : DocumentCompleteCallback
//  Callback function which fires when document layout completes.
//**********************************************
    function DocumentCompleteCallback() {
      setTimeout("ShowFilledPagesAndHideExcessPages()", 30);
    }

//**********************************************
// FUNCTION : ShowFilledPagesAndHideExcessPages
// This function used to hide all extra pages in original MS example.
//   now it just hides pages that are excluded by page selection and
//   resets header/footer info and cost totals.
//**********************************************
    function ShowFilledPagesAndHideExcessPages() {
      // Hide pages which are excluded by page selection
      ChangeShownPages();

      // Check how many pages there are for the header
      if (LastPage == -1) {
        headfoot.pageTotal = document.all.tags("DEVICERECT").length;
      } else {
        headfoot.pageTotal = LastPage;
      }
      AddPageTotalToPages();

      // Reset all totals
      Recount(headfoot.pageTotal);
    }

//**********************************************
// FUNCTION : ChangeShownPages
// Hide all of the pages which are excluded by the page selection
//   by setting their position to 'absolute' the style sheet moves
//   them off the screen.
//**********************************************
    function ChangeShownPages() {
      var i = 1;
      var myTemp = 0;
      var LastObject = 0;

      // Find the last page with content
      var LastObject = document.all.tags("DEVICERECT").length;
      if (LastPage == -1) {
        myTemp = LastObject;
      } else {
        myTemp = LastPage;
      }

      while (document.all("page" + i)) {
        // If there is a page selection specified
        if (printer.selectedPages == true) {

          // Validate selections. Used when changing orientation changes the pagination.
          if (myTemp < printer.pageTo) {
            PageTo.value = myTemp;
            printer.pageTo = myTemp;
          }
          if (myTemp < printer.pageFrom) {
            PageFrom.value = myTemp;
            printer.pageFrom = myTemp;
          }

          // Hide where relevant
          if (printer.pageFrom > i || printer.pageTo < i) {
            document.all("page" + i).style.position = "absolute";
          } else {
            document.all("page" + i).style.position = "static";
          }

        // Otherwise, only show pages with real content
        } else {
          if (myTemp < i) {
            document.all("page" + i).style.position = "absolute";
          } else {
            document.all("page" + i).style.position = "static";
          }
        }
        i++;
      }
    }

//**********************************************
// FUNCTION : AddPageTotalToPages
// Add page totals to header
//**********************************************
    function AddPageTotalToPages() {
      oSpanCollection = document.all.tags("span");
      for (i = 0; i < oSpanCollection.length; i++) {
        if (oSpanCollection[i].className == "hfPageTotal") oSpanCollection[i].innerText = headfoot.pageTotal;
      }
    }

//**********************************************
// FUNCTION : Recount
// Recount all pages and set totals in printing windows
//**********************************************
    function Recount(newTotal) {
      myTotalPages = newTotal;
      InitTotals();
    }
